Subject: [dhcwg] FW: I-D Action: draft-templin-duid-ipv6-01.txt

From: Antonio Escalera <[email-masked]>
Date: Mon, 11 Jan 2021 22:55:41 -0500

Hi Fred,

I responded inline below.

On Mon, Jan 11, 2021, 2:45 PM Templin (US), Fred L <
[email-masked]> wrote:

> Hi Antonio,
>
>
>
> Continuing on from the text you quoted, RFC8415 goes on to say: “Clients
> and servers
>
> MUST NOT restrict DUIDs to the types defined in this document, as
> additional DUID types
>
> may be defined in the future.” And, this document is exactly such a future
> document.
>
This quote is referencing DUID types, not DUIDs themselves. Additional
types are permitted, but interpreting meaning from a DUID in this manner is
explicitly prohibited in this case. In fact, it is the express intention of
the authors of (RFC8415)[1] that the DUID be irrespective of physical or
logical changes to the configuration of the networked device:

"That is, the DUID used by a client or server SHOULD NOT change over time
if at all possible; for example, a device's DUID should not change as a
result of a change in the device's network hardware or changes to virtual
interfaces"

I would suggest submitting a document to supersede RFC8415 first. I don't
understand your reasoning for wanting to change these requirements --
perhaps you have valid reasons. Nonetheless, a new DHCPv6 proposal would be
required before this can be considered.

>
>
> Also, if the text you quoted were taken to the absolute letter of the law,
> then there
>
> would only be one DUID type for all time, with only the length field
> differentiating.
>
False. To continue quoting (RFC8415)[1]

DHCP servers use DUIDs to
identify clients for the selection of configuration parameters and in
the association of IAs with clients.  DHCP clients use DUIDs to
identify a server in messages where a server needs to be identified.

IA, or Identity Association, is defined in the same document (here)[2] as:

The goal of DUID is to associate IA's with a client. Each server and
client has only one.

Your proposed RFC would prohibit multiple interfaces.

But, we already have four DUID types (DUID-LL, DUID-EN, DUID-LLT, DUID-UUID)
>
> and this document would be introducing a 5th type. So, somewhere along
> the line,
>
> someone decided that it would be useful to distinguish different DUID
> types.
>
>
>
The different DUID types in existence do not violate the aforementioned
quote in the previous email.

> Thanks - Fred

[1]: https://tools.ietf.org/html/rfc8415#section-11

[2]: https://tools.ietf.org/html/rfc8415#section-4.2

Conflicting standards with no clear reasoning for divergence and no
documentation defining changes are useless.

Regards,

Antonio

---

From: "Templin (US), Fred L" <[email-masked]>
Date: Tue, 12 Jan 2021 18:57:50 +0000

Thanks Antonio,

Fred

From: Antonio Escalera [mailto:[email-masked]]
Sent: Tuesday, January 12, 2021 10:47 AM
To: Templin (US), Fred L <[email-masked]>
Cc: Eric Vyncke (evyncke) <[email-masked]>; [email-masked]; dhcwg <[email-masked]>; Dickson (US), Sean M <[email-masked]>
Subject: Re: [dhcwg] I-D Action: draft-templin-duid-ipv6-01.txt

Ahhhh, see this makes it more clear. So your idea is akin to a hostname except implemented over IPv6. I think making it clear that the intention is to assign the IP address to a loopback interface would make the draft more acceptable.

I really like this idea. Thanks for clearing that up.

I primarily work on clouds, this would be especially useful for containers in environments where multiple networking interfaces are exposed. Now to implement a CNI over ipv6...

Best,
Antonio
On Tue, Jan 12, 2021, 11:42 AM Templin (US), Fred L <[email-masked]<mailto:[email-masked]>> wrote:
Eric, see below:

> -----Original Message-----
> From: Eric Vyncke (evyncke) [mailto:[email-masked]<mailto:[email-masked]>]
> Sent: Tuesday, January 12, 2021 5:50 AM
> To: Templin (US), Fred L <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; dhcwg <[email-masked]<mailto:[email-masked]>>
> Cc: Dickson (US), Sean M <[email-masked]<mailto:[email-masked]>>
> Subject: Re: I-D Action: draft-templin-duid-ipv6-01.txt
>
> <without any hat>
>
> Hello Fred,
>
> Just wondering how would this new DUID could be used when several interfaces sharing the same DUID will request some
> address(es)/prefix(es) over DHCPv6 ?

I think this may have been addressed in my response to Mark, but the intention is
that an IPv6 address that is independent of any of the node's physical interfaces
and that provides an identity for the node is the address that would go into the
DUID. [RFC7401][draft-ietf-drip-rid] are two examples where a valid IPv6 address
is generated and intended to provide an interface-independent, unique and long
lived identity for the node. Other examples may be defined in the future as well.

> If you allow me to guess your use case, then would DUID type based on the private enterprise number (FAA and EASA have ones)
> could be used ? This would be simpler than requesting a new DUID type

I was actually thinking that DUID-UUID would be a candidate surrogate DUID because
the body is exactly 128bits the same as for IPv6 addresses. But, by definition, UUIDs
are *not* IPv6 addresses since they do not observe the [RFC4291] address architecture.
Per your suggestion, a private enterprise number could be gotten (AERO also already
has one) and then use DUID-EN instead. But, then there would not be a standards
track specification guaranteeing that the holder of the private enterprise number
would consistently and forever always apply IPv6 address architecture semantics to
their application of the private enterprise number.

Hence, the proposal for DUID-V6ADDR. Or, if folks would prefer a different name
I could imagine alternatives such as DUID-IN6, DUID-IPV6, etc. Any preferences?

Thanks - Fred

> Hope this helps,
>
> Regards
>
> -éric
>
> </without any hat>
>
> -----Original Message-----
> From: ipv6 <[email-masked]<mailto:[email-masked]>> on behalf of "Templin (US), Fred L" <[email-masked]<mailto:[email-masked]>>
> Date: Monday, 11 January 2021 at 19:47
> To: "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, dhcwg <[email-masked]<mailto:[email-masked]>>
> Cc: "Dickson (US), Sean M" <[email-masked]<mailto:[email-masked]>>
> Subject: FW: I-D Action: draft-templin-duid-ipv6-01.txt
>
>     Hi, more and more IPv6 address generation methods are being specified that
>     intend to generate IPv6 addresses that are highly likely to be unique on either
>     a global scale or unique within a bounded service domain. So much so, that
>     some address generation methods intend for the IPv6 addresses to be usable
>     as node identifiers.
>
>     Recognizing this, this document proposes a new DHCPv6 DUID type known
>     as "DHCP-V6ADDR" that includes an IPv6 address in the body of the DUID. In
>     this way, IPv6 addresses produced by address generation methods intending
>     to generate a node ID can be used as unique identifiers in DHCPv6 message
>     exchanges. This would introduce a single new DUID type, for which the IANA
>     allocation policy is  "standards action".
>
>     Alternatively, a separate DUID type could be allocated for each IPv6 address
>     generation method. However, that approach may result in additional IANA
>     allocations and would require implementation updates every time a new
>     address generation method is specified. Hence, a single generic DUID type
>     for all IPv6 generation methods is proposed, but open for discussion.
>
>     Comments on the list welcome.
>
>     Fred
>
>     -----Original Message-----
>     From: I-D-Announce [mailto:[email-masked]<mailto:[email-masked]>] On Behalf Of [email-masked]<mailto:[email-masked]>
>     Sent: Monday, January 11, 2021 10:21 AM
>     To: [email-masked]<mailto:[email-masked]>
>     Subject: I-D Action: draft-templin-duid-ipv6-01.txt
>
>     A New Internet-Draft is available from the on-line Internet-Drafts directories.
>
>
>             Title           : The IPv6 Address-based DHCPv6 Unique Identifier (DUID-V6ADDR)
>             Author          : Fred L. Templin
>       Filename        : draft-templin-duid-ipv6-01.txt
>       Pages           : 7
>       Date            : 2021-01-11
>
>     Abstract:
>        This document defines a new DHCPv6 Unique Identifier (DUID) type
>        called DUID-V6ADDR that contains a single 128 bit IPv6 address.
>        DUID-V6ADDR makes it possible for devices to use suitably-derived
>        unique IPv6 addresses to identify themselves to DHCPv6 servers and/or
>        other network nodes.
>
>
>     The IETF datatracker status page for this draft is:
>     https://datatracker.ietf.org/doc/draft-templin-duid-ipv6/
>
>     There are also htmlized versions available at:
>     https://tools.ietf.org/html/draft-templin-duid-ipv6-01
>     https://datatracker.ietf.org/doc/html/draft-templin-duid-ipv6-01
>
>     A diff from the previous version is available at:
>     https://www.ietf.org/rfcdiff?url2=draft-templin-duid-ipv6-01
>
>
>     Please note that it may take a couple of minutes from the time of submission
>     until the htmlized version and diff are available at tools.ietf.org<http://tools.ietf.org>.
>
>     Internet-Drafts are also available by anonymous FTP at:
>     ftp://ftp.ietf.org/internet-drafts/
>
>
>     _______________________________________________
>     I-D-Announce mailing list
>     [email-masked]<mailto:[email-masked]>
>     https://www.ietf.org/mailman/listinfo/i-d-announce
>     Internet-Draft directories: http://www.ietf.org/shadow.html
>     or ftp://ftp.ietf.org/ietf/1shadow-sites.txt
>
>     --------------------------------------------------------------------
>     IETF IPv6 working group mailing list
>     [email-masked]<mailto:[email-masked]>
>     Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6
>     --------------------------------------------------------------------

_______________________________________________
dhcwg mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/dhcwg